class lamp ($mysql_password = undef) {
  
  if ($mysql_password == undef) {
    $_mysql_password = 'reallysafepassword'
  }
  
  
#  class { '::mysql::server':
#    root_password           => $_mysql_password,
#    remove_default_accounts => true,
#  }
  
  
  exec { 'apt-update':
    command => '/usr/bin/apt-get update'
  }
  
  package { 'apache2':
    require => Exec['apt-update'],        # require 'apt-update' before installing
    ensure => installed,
  }

  # ensure apache2 service is running
  service { 'apache2':
    require => Package['apache2'],
    ensure => running,
  }

  # install mysql-server package
  package { 'mysql-server':
    require => Exec['apt-update'],        # require 'apt-update' before installing
    ensure => installed,
  }

  # ensure mysql service is running
  service { 'mysql':
  require => Package['mysql-server'],
    ensure => running,
  }

  # install php5 package
  package { 'php5':
    require => Exec['apt-update'],        # require 'apt-update' before installing
    ensure => installed,
  }

  # install php5-mysql package
  package { 'php5-mysql':
    require => Exec['apt-update'],        # require 'apt-update' before installing
    ensure => installed,
  }
  
  # create test
  file { '/var/www/html/index.php':
    #path    => '/var/www/html/index.php',
    ensure  => file,
    require => Package['apache2'],
    #source  => "puppet:///modules/lamp/index.php",
    content => template("lamp/index.php"),
  }
  
  # remove unnecessary index.html
  file { '/var/www/html/index.html':
    ensure  => absent,
    require => Package['apache2'],
  }
  
  # set mysql root password (won't work if root already has password)
  exec { "Set MySQL server root password":
    subscribe => [ Package["mysql-server"] ],
    refreshonly => true,
    unless => "mysqladmin -uroot -p$_mysql_password status",
    path => "/bin:/usr/bin",
    command => "mysqladmin -uroot password $_mysql_password",
  }

}

